<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Bouncing Rect</title>
    <style>
        #canvas {
            width: 600px;
            height: 400px;
            position: relative;
            background-color: #f9f9f9;
            border: medium solid #333;
        }
    </style>
    <script src="rect.js"></script>
</head>
<body>
    <h1>Bouncing Rect</h1>
    <p>
        <label for="interval">Interval [ms]: </label>
        <input type="number" id="interval" value="5" min="1" max="1000" onchange="restart()"/>
        <button id="add" onclick="add()">Add Rect</button>
        <button id="run" onclick="run()">Start</button>
    </p>
    <div id="canvas"></div>

    <script>
        var intervalId = null;
        var rects      = [];

        function add() {
            rects.push(new Rect({
                id: rects.length,
                parent: document.getElementById('canvas'),
                side: 30,
                width: 600,
                height: 400,
            }));
        }

        function run() {
            if (intervalId) {
                stopRunner();
            } else {
                startRunner();
            }
        }

        function startRunner() {
            function scan() {
                rects.forEach(function (r) {
                    r.move.apply(r);
                });
            }

            var intervalField   = document.getElementById('interval');
            intervalId          = setInterval(scan, intervalField.value);
            
            var runButton       = document.getElementById('run');
            runButton.innerHTML = 'Stop';
        }

        function stopRunner() {
            clearInterval(intervalId);
            intervalId          = null;
            
            var runButton       = document.getElementById('run');
            runButton.innerHTML = 'Start';
        }

        function restart() {
            if (!intervalId) return;
            stopRunner();
            startRunner();
        }
    </script>
</body>
</html>
